      SUBROUTINE TOTABSOR(PH2O,PCO2,PTOT,TG,TW,XL,ABSH2O,ABSCO2,ABSTOT)
C CALCULATES THE TOTAL ABSORPTIVITY OF A STEAM-CARBON DIOXIDE-NITROGEN MIXTURE,
C USING THE CORRELATION OF LECKNER 
C INPUT: 
C   PH2O  = PARTIAL PRESSURE OF STEAM (BAR) 
C   PCO2  = PARTIAL PRESSURE OF CARBON DIOXIDE (BAR) 
C   PTOT  = TOTAL PRESSURE OF GAS MIXTURE (BAR) 
C   TG    = GAS TEMPERATURE (K) 
C   TW    = WALL TEMPERATURE (K) 
C   XL    = GEOMETRIC PATH LENGTH (CM) 
C OUTPUT: 
C   ABSH2O= TOTAL EMISSIVITY OF WATER VAPOR 
C   ABSCO2= TOTAL EMISSIVITY OF CARBON DIOXIDE
C   ABSTOT= TOTAL EMISSIVITY OF GAS MIXTURE (CONSIDERING OVERLAP EFFECTS) 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      XLAD=XL*TW/TG
      CALL    TOTEMISS(PH2O,PCO2,PTOT,TW,XLAD,ABSH2O,ABSCO2,ABSTOT)
      TFAC=DSQRT(TG/TW)
      ABSH2O=ABSH2O*TFAC
      ABSCO2=ABSCO2*TFAC
      ABSTOT=ABSTOT*TFAC
      RETURN
      END
